EXTRA_WARNINGS = -Wshadow -Wpointer-arith -Wcast-qual \
				 -Wwrite-strings -Waggregate-return -Wsign-compare \
				 -Wconversion #-Winit-self

CC = gcc -Wall -g #-ggdb -fstack-check -DDEBUG -g -DINCORE
#CC = g++ -Wall ${EXTRA_WARNINGS} -O2 -march=pentium4 -malign-double -fomit-frame-pointer
#-march=athlon64

ANTHILL = "${HOME}/Anthill/"

CFLAGS = -I${ANTHILL}/ -I${ANTHILL}/FilterDev/ -I${ANTHILL}/FilterData/ \
		 -I${ANTHILL}/AbstractDataTypes/ -I${ANTHILL}/AbstractDataTypes/cser \
		 -fPIC

#CLIBS = -lpvm3 -lexpat -ldl -L. -L/lib/LINUX -L${ANTHILL_DIR}/ -lds #-lefence

CLIBS = -lexpat -ldl -L${ANTHILL} -lah #-lefence


all:target

target: main distributor.so reader.so centroid.so labelpolicy.so final.so

distributor.so: distributor.c dimensions.c dimensions.h procedures.c procedures.h constants.h 
	${CC} -shared -o distributor.so distributor.c dimensions.c procedures.c ${CFLAGS} ${CLIBS}

reader.so: reader.c dimensions.c dimensions.h constants.h IntVector.c IntVector.h procedures.c procedures.h data.c data.h memory_data.c memory_data.h structs.h message_data.c message_data.h
	${CC} -shared -o reader.so reader.c dimensions.c IntVector.c procedures.c data.c memory_data.c message_data.c ${CFLAGS} ${CLIBS} 

centroid.so: centroid.c constants.h procedures.c procedures.h
	${CC} -shared -o centroid.so centroid.c procedures.c ${CFLAGS} ${CLIBS}

final.so: final.c constants.h procedures.c procedures.h data.c data.h memory_data.c memory_data.h message_data.c message_data.h
	${CC} -shared -o final.so final.c procedures.c data.c memory_data.c message_data.c ${CFLAGS} ${CLIBS}

labelpolicy.so: labelpolicy.c 
	${CC} -shared -o labelpolicy.so labelpolicy.c ${CFLAGS} ${CLIBS}

#dimensions.so: dimensions.c
#	${CC} ${CFLAGS} ${CLIBS} -shared -o dimensions.so dimensions.c

main: main.c constants.h
	${CC} main.c -o main ${CFLAGS} ${CLIBS}

clean:
	rm -f *.o reader.so centroid.so labelpolicy.so dimensions.so distributor.so final.so main log*
